function parser(string, startIndex)
{
   ptr = startIndex;
   str = string;

   ///////////////////////////////////////////////////////////////////////////
   //////////////////// Raw Fetch ////////////////////////////////////////////
   ///////////////////////////////////////////////////////////////////////////
   this.fetch04 = function()
   {
      var tmp = str.charAt(ptr);
      ptr += 1;
      return tmp;
   }
   this.fetch08 = function()
   {
      var tmp = str.charAt(ptr) + str.charAt(ptr + 1);
      ptr += 2;
      return tmp;
   }
   this.fetch16 = function()
   {
      var tmp = str.charAt(ptr + 2) + str.charAt(ptr + 3) + str.charAt(ptr) + str.charAt(ptr + 1);
      ptr += 4;
      return tmp;
   }
   this.fetch24 = function()
   {
      var tmp = str.charAt(ptr + 4) + str.charAt(ptr + 5) + str.charAt(ptr + 2) + str.charAt(ptr + 3) + str.charAt(ptr) + str.charAt(ptr + 1);
      ptr += 6;
      return tmp;
   }
   this.fetch32 = function()
   {
      var tmp = str.charAt(ptr + 6) + str.charAt(ptr + 7) + str.charAt(ptr + 4) + str.charAt(ptr + 5) + str.charAt(ptr + 2) + str.charAt(ptr + 3) + str.charAt(ptr) + str.charAt(ptr + 1);
      ptr += 8;
      return tmp;
   }

   ///////////////////////////////////////////////////////////////////////////
   //////////////////// Hex Fetch ////////////////////////////////////////////
   ///////////////////////////////////////////////////////////////////////////
   this.fetchHex04 = function()
   {
      return '0x' + this.fetch04();
   }
   this.fetchHex08 = function()
   {
      return '0x' + this.fetch08();
   }
   this.fetchHex16 = function()
   {
      return '0x' + this.fetch16();
   }
   this.fetchHex24 = function()
   {
      return '0x' + this.fetch24();
   }
   this.fetchHex32 = function()
   {
      return '0x' + this.fetch32();
   }

   ///////////////////////////////////////////////////////////////////////////
   //////////////////// Unsigned Fetch ///////////////////////////////////////
   ///////////////////////////////////////////////////////////////////////////
   this.fetchU04 = function()
   {
      return this.fetchHex04() / 1;
   }
   this.fetchU08 = function()
   {
      return this.fetchHex08() / 1;
   }
   this.fetchU16 = function()
   {
      return this.fetchHex16() / 1;
   }
   this.fetchU24 = function()
   {
      return this.fetchHex24() / 1;
   }
   this.fetchU32 = function()
   {
      return this.fetchHex32() / 1;
   }

   ///////////////////////////////////////////////////////////////////////////
   //////////////////// Signed Fetch /////////////////////////////////////////
   ///////////////////////////////////////////////////////////////////////////
   this.fetchS04 = function()
   {
      tmp = this.fetchHex04();
      if(tmp & "0x8")
         return tmp - "0xF" - 1;
      else
         return tmp / 1;
   }
   this.fetchS08 = function()
   {
      tmp = this.fetchHex08();
      if(tmp & "0x80")
         return tmp - "0xFF" - 1;
      else
         return tmp / 1;
   }
   this.fetchS16 = function()
   {
      tmp = this.fetchHex16();
      if(tmp & "0x8000")
         return tmp - "0xFFFF" - 1;
      else
         return tmp / 1;
   }
   this.fetchS24 = function()
   {
      tmp = this.fetchHex24();
      if(tmp & "0x800000")
         return tmp - "0xFFFFFF" - 1;
      else
         return tmp / 1;
   }
   this.fetchS32 = function()
   {
      tmp = this.fetchHex32();
      if(tmp & "0x80000000")
         return tmp - "0xFFFFFFFF" - 1;
      else
         return tmp / 1;
   }
   
   ///////////////////////////////////////////////////////////////////////////
   //////////////////// Real Fetch ///////////////////////////////////////////
   ///////////////////////////////////////////////////////////////////////////
   this.fetchR32 = function()
   {
      var a = this.fetchU32();
      var r = (a & 0x7fffff | 0x800000) * 1.0 / Math.pow(2,23) * Math.pow(2,  ((a>>23 & 0xff) - 127));
      return  r * (((a >> 31) & 0x1) ? -1.0 : 1.0);
   }
   this.fetchR64 = function()
   {
      var b = this.fetchU32();
      var a = this.fetchU32();
      var e = (a >> 52 - 32 & 0x7ff) - 1023;
      var r = (a & 0xfffff | 0x100000) * 1.0 / Math.pow(2,52-32) * Math.pow(2, e) +          
        b * 1.0 / Math.pow(2, 52) * Math.pow(2, e);
      return  r * (((a >> 31) & 0x1) ? -1.0 : 1.0);
   }
}